from flask_restx import Namespace, Resource, fields
from flask_restx import reqparse
import s3Client
import logging

# Exported namespace
api = Namespace('search', description='Searching for memes')

def getClientSafely():
    logging.debug("Getting a client safely...")
    client = None
    try:
        client = s3Client.getClient()
    except Exception as e:
        logging.critical("Failed to retrive a client : " + str(e))

    return client


@api.route('/exact/<string:query>')
@api.doc(params={
    'query': 'Name of the meme you are looking for'
    })
class exactSearch(Resource):
    @api.doc('search')
    @api.response(200, 'Sucess')
    @api.response(500, 'S3 Error')
    def get(self, query):
        logging.debug("Getting a client safely...")
        client = getClientSafely()
        if client is None:
            return {
                    "message": "Error connecting to S3"
                }, 500
        if query in client.getCurrentMemeList():
            return "nice"
        else:
            return "boo"

